import { ThreeObject3d } from '@angular-three/core';
import { ContentChildren, Directive } from '@angular/core';
import { LOD } from 'three';
import { LodLevelDirective } from './lod-level.directive';
export class LodDirective extends ThreeObject3d {
    ngOnInit() {
        this.init();
    }
    ngAfterContentInit() {
        this.ngZone.runOutsideAngular(() => {
            if (this.lodLevels) {
                this.lodLevels.forEach((lodLevel) => {
                    if (lodLevel.hostObject) {
                        this._lod.addLevel(lodLevel.hostObject, lodLevel.distance);
                    }
                });
            }
        });
    }
    initObject() {
        this._lod = new LOD();
    }
    get object3d() {
        return this._lod;
    }
}
LodDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-lod',
                exportAs: 'ngtLod',
                providers: [{ provide: ThreeObject3d, useExisting: LodDirective }],
            },] }
];
LodDirective.propDecorators = {
    lodLevels: [{ type: ContentChildren, args: [LodLevelDirective,] }]
};
//# sourceMappingURL=lod.directive.js.map