import { ThreeObject3d, ThreeObject3dMaterialGeometry, } from '@angular-three/core';
import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { ThreeMaterial } from '@angular-three/core/materials';
import { ContentChild, Directive } from '@angular/core';
import { Points } from 'three';
export class PointsDirective extends ThreeObject3dMaterialGeometry {
    set materialDirective(v) {
        if (this.material == null) {
            this.material = v.material;
        }
    }
    set bufferGeometryDirective(v) {
        if (this.geometry == null) {
            this.geometry = v.bufferGeometry;
        }
    }
    get objectType() {
        return Points;
    }
}
PointsDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-points',
                exportAs: 'ngtPoints',
                providers: [
                    { provide: ThreeObject3d, useExisting: PointsDirective },
                ],
            },] }
];
PointsDirective.propDecorators = {
    materialDirective: [{ type: ContentChild, args: [ThreeMaterial,] }],
    bufferGeometryDirective: [{ type: ContentChild, args: [ThreeBufferGeometry,] }]
};
//# sourceMappingURL=points.directive.js.map