import { ThreeObject3d } from '@angular-three/core';
import { Directive, Optional, Input, ContentChildren, NgModule } from '@angular/core';
import { LOD } from 'three';
import { CommonModule } from '@angular/common';

class LodLevelDirective {
    constructor(hostObject3d) {
        this.hostObject3d = hostObject3d;
    }
    get hostObject() {
        var _a;
        return (_a = this.hostObject3d) === null || _a === void 0 ? void 0 : _a.object3d;
    }
}
LodLevelDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngtLodLevel]',
            },] }
];
LodLevelDirective.ctorParameters = () => [
    { type: ThreeObject3d, decorators: [{ type: Optional }] }
];
LodLevelDirective.propDecorators = {
    distance: [{ type: Input, args: ['ngtLodLevel',] }]
};

class LodDirective extends ThreeObject3d {
    ngOnInit() {
        this.init();
    }
    ngAfterContentInit() {
        this.ngZone.runOutsideAngular(() => {
            if (this.lodLevels) {
                this.lodLevels.forEach((lodLevel) => {
                    if (lodLevel.hostObject) {
                        this._lod.addLevel(lodLevel.hostObject, lodLevel.distance);
                    }
                });
            }
        });
    }
    initObject() {
        this._lod = new LOD();
    }
    get object3d() {
        return this._lod;
    }
}
LodDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-lod',
                exportAs: 'ngtLod',
                providers: [{ provide: ThreeObject3d, useExisting: LodDirective }],
            },] }
];
LodDirective.propDecorators = {
    lodLevels: [{ type: ContentChildren, args: [LodLevelDirective,] }]
};

class LodModule {
}
LodModule.decorators = [
    { type: NgModule, args: [{
                declarations: [LodDirective, LodLevelDirective],
                imports: [CommonModule],
                exports: [LodDirective, LodLevelDirective],
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { LodDirective, LodLevelDirective, LodModule };
//# sourceMappingURL=angular-three-core-lod.js.map
