import { ThreeObject3dMaterialGeometry, ThreeObject3d } from '@angular-three/core';
import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { ThreeMaterial } from '@angular-three/core/materials';
import { Directive, ContentChild, NgModule } from '@angular/core';
import { Points } from 'three';
import { CommonModule } from '@angular/common';

class PointsDirective extends ThreeObject3dMaterialGeometry {
    set materialDirective(v) {
        if (this.material == null) {
            this.material = v.material;
        }
    }
    set bufferGeometryDirective(v) {
        if (this.geometry == null) {
            this.geometry = v.bufferGeometry;
        }
    }
    get objectType() {
        return Points;
    }
}
PointsDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngt-points',
                exportAs: 'ngtPoints',
                providers: [
                    { provide: ThreeObject3d, useExisting: PointsDirective },
                ],
            },] }
];
PointsDirective.propDecorators = {
    materialDirective: [{ type: ContentChild, args: [ThreeMaterial,] }],
    bufferGeometryDirective: [{ type: ContentChild, args: [ThreeBufferGeometry,] }]
};

class PointsModule {
}
PointsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    PointsDirective
                ],
                imports: [
                    CommonModule
                ],
                exports: [
                    PointsDirective
                ]
            },] }
];

/**
 * Generated bundle index. Do not edit.
 */

export { PointsDirective, PointsModule };
//# sourceMappingURL=angular-three-core-points.js.map
